using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Gam.Practices;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Drawing;
using System.Collections;

namespace GridGroup
{
    public partial class Form1 : Form
    {
        # region delegates
        // A delegate type for hooking up change notifications.
        public delegate void ChangedEventHandler(object sender, EventArgs e);
        # endregion

        # region enums

        public enum days
        {
            None = 0,
            Today,
            Yesterday,
            Monday,
            Tuesday,
            Wednesday,
            Thursday,
            Friday,
            Saturday,
            Sunday,
            LastWeek,
            TwoWeeksAgo,
            ThreeWeeksAgo,
            LastMonth,
            Older,
            NextWeek,
            TwoWeeksTime,
            ThreeWeeksTime,
            InTheFuture
        }

        public enum taskIcon
        { 
            Task = 0, 
            Recurrence = 1 
        }

        # endregion

        private ImageList taskIcons;

        public static int r = 189, g = 215, b = 252, r1 = 220, g1 = 235, b1 = 254;

        public Form1()
        {
            InitializeComponent();

            InitGrid();
        }

        private void InitGrid()
        {
            Color paleBlue = Color.FromArgb(Form1.r, Form1.g, Form1.b);
            
            #region Initialise the icons

            taskIcons = new ImageList();
            taskIcons.Images.Add(Properties.Resources.TaskIcon);
            taskIcons.Images.Add(Properties.Resources.TaskRecurrenceIcon);

            #endregion

            #region Grid styles

            this.gridGroupingControl1.BaseStyles.Add("Overdue");
            this.gridGroupingControl1.BaseStyles.Add("Completed");

            this.gridGroupingControl1.BaseStyles["Overdue"].StyleInfo.TextColor = Color.Red;
            this.gridGroupingControl1.BaseStyles["Completed"].StyleInfo.TextColor = Color.DarkGray;

            #endregion

            #region Grid wide Settings

            // Turn the themes off as we are targeting windows 2000 at the moment
            this.gridGroupingControl1.ThemesEnabled = false;

            // Don't show the add new row in the grid
            this.gridGroupingControl1.TableDescriptor.AllowNew = false;

            // Prevent the grid from being edited
            this.gridGroupingControl1.TableDescriptor.AllowEdit = false;
            
            // Don't allow any record cells (data cells) to get focus
            this.gridGroupingControl1.TableDescriptor.Appearance.AnyRecordFieldCell.CellType = "Static";

            // Make the grid look pretty
            if (this.gridGroupingControl1.ThemesEnabled)
                this.gridGroupingControl1.TableOptions.GridVisualStyles = GridVisualStyles.Office2007Blue;            

            // Hide the caption row just above the grid
            this.gridGroupingControl1.TopLevelGroupOptions.ShowCaption = false;
            
            // Expand all the groups by default
            this.gridGroupingControl1.ChildGroupOptions.IsExpandedInitialValue = true;
                       
            // Show the group drop area so the user can perform grouping by dragging columns
            this.gridGroupingControl1.ShowGroupDropArea = true;

            // Remove the text (name) in the Group Driop Area
            this.gridGroupingControl1.TableDescriptor.Name = "";            

            // Set the height of the header column
            this.gridGroupingControl1.TableOptions.ColumnHeaderRowHeight = 22;

            // Set the height of the grouping caption row
            this.gridGroupingControl1.TableOptions.CaptionRowHeight = 30;

            // Set the standard row height
            this.gridGroupingControl1.TableOptions.RecordRowHeight = 22;

            // Remove the row selecter from the left of the grid
            this.gridGroupingControl1.TableOptions.ShowRowHeader = false;

            // Remove all the vertical lines
            this.gridGroupingControl1.TableModel.Properties.DisplayVertLines = false;

            // Optimisations
            //this.gridGroupingControl1.TableOptions.AllowSortColumns = false;
            //this.gridGroupingControl1.TableModel.AllowAdjustCellValue = false;
            //this.gridGroupingControl1.AutoPopulateRelations = false;
            //this.gridGroupingControl1.CacheRecordValues = false;            
            this.gridGroupingControl1.AllowSwapDataViewWithDataTableList = false;
            this.gridGroupingControl1.Table.AllowThreading = false;
            //this.gridGroupingControl1.TopLevelGroupOptions.
            //this.gridGroupingControl1.Table.WithoutCounter = true;
            //this.gridGroupingControl1.Table.RecordsAsDisplayElements = false;
            //this.gridGroupingControl1.Engine.AllowCacheStyles = true;

            #endregion

            // Row line color
            this.gridGroupingControl1.Appearance.AnyRecordFieldCell.Borders.Bottom = new GridBorder(GridBorderStyle.Solid, paleBlue, GridBorderWeight.ExtraThin);
            this.gridGroupingControl1.Appearance.GroupIndentCell.Borders.Bottom = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid, Color.FromArgb(Form1.r, Form1.g, Form1.b), Syncfusion.Windows.Forms.Grid.GridBorderWeight.ExtraThin);

            // Row selection - set single row select
            this.gridGroupingControl1.TableOptions.AllowSelection = GridSelectionFlags.None;
            this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.One;
            this.gridGroupingControl1.TableOptions.ListBoxSelectionCurrentCellOptions = GridListBoxSelectionCurrentCellOptions.None;
            this.gridGroupingControl1.TableModel.Options.ShowCurrentCellBorderBehavior = GridShowCurrentCellBorder.HideAlways;

            // Expend/Collapse - set the icon and size
            this.gridGroupingControl1.Appearance.GroupCaptionPlusMinusCell.BorderMargins.Top = 12;
            this.gridGroupingControl1.Appearance.GroupCaptionPlusMinusCell.CellType = "Image";
            if (this.gridGroupingControl1.ChildGroupOptions.IsExpandedInitialValue)
                this.gridGroupingControl1.Appearance.GroupCaptionPlusMinusCell.CellValue = Properties.Resources.MinusImage;
            else
                this.gridGroupingControl1.Appearance.GroupCaptionPlusMinusCell.CellValue = Properties.Resources.PlusImage;

            // Group Drop Panel - set styles
            this.gridGroupingControl1.GroupDropPanel.BackColor = Color.FromArgb(Form1.r, Form1.g, Form1.b);
            this.gridGroupingControl1.GroupDropPanel.Height = 30;

            // Group Drop Panel Splitter - set styles (this doesn't seem to do anything)            
            this.gridGroupingControl1.Splitter.BackColor = Color.FromArgb(Form1.r, Form1.g, Form1.b);
            this.gridGroupingControl1.Splitter.Height = 2;

            #region Group Header

            // Group Header - set the back colour
            this.gridGroupingControl1.Appearance.GroupCaptionCell.BackColor = Color.White;

            // Group Header - set the header caption to bold
            this.gridGroupingControl1.Appearance.GroupCaptionCell.Font.Bold = true;

            // Group Header - set the alignment of the text
            if (this.gridGroupingControl1.ThemesEnabled)
                this.gridGroupingControl1.Appearance.GroupCaptionCell.VerticalAlignment = this.gridGroupingControl1.Appearance.GroupCaptionPlusMinusCell.VerticalAlignment;
            else
                this.gridGroupingControl1.Appearance.GroupCaptionCell.VerticalAlignment = GridVerticalAlignment.Bottom;

            // Group Header - set the Borders

            this.gridGroupingControl1.Appearance.GroupCaptionCell.BorderMargins = new GridMarginsInfo(new GridMargins(0, 0, 0, 0));

            //this.gridGroupingControl1.Appearance.GroupCaptionCell.Borders.Top = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.GroupCaptionCell.Borders.Left = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.GroupCaptionCell.Borders.Bottom = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.GroupCaptionCell.Borders.Right = new GridBorder(GridBorderStyle.None);

            //this.gridGroupingControl1.Appearance.GroupIndentCell.Borders.Top = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.GroupIndentCell.Borders.Left = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.GroupIndentCell.Borders.Bottom = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.GroupIndentCell.Borders.Right = new GridBorder(GridBorderStyle.None);            
            
            this.gridGroupingControl1.BorderStyle = BorderStyle.None;
            this.gridGroupingControl1.Appearance.GroupIndentCell.CellAppearance = GridCellAppearance.Flat;
            this.gridGroupingControl1.Appearance.AnyCell.CellAppearance = GridCellAppearance.Flat;
            this.gridGroupingControl1.Appearance.AnyCell.Borders.All = new GridBorder(GridBorderStyle.NotSet);
            //this.gridGroupingControl1.Appearance.AnyCell.Borders.Right.Style = GridBorderStyle.NotSet;
            //this.gridGroupingControl1.Appearance.GroupCaptionCell.Themed = false;
            //this.gridGroupingControl1.Appearance.GroupCaptionCell.Borders.All = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.GroupIndentCell.Borders.All = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.RowHeaderCell.Borders.All = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.ColumnHeaderCell.Borders.All = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.GroupCaptionSummaryCell.Borders.All = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.GroupFooterRowHeaderCell.Borders.All = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.GroupFooterSectionCell.Borders.All = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.GroupHeaderIndentCell.Borders.All = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.GroupHeaderRowHeaderCell.Borders.All = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.GroupHeaderSectionCell.Borders.All = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.GroupPreviewRowHeaderCell.Borders.All = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.TableOptions.GridLineBorder = new GridBorder(GridBorderStyle.None);

            //this.gridGroupingControl1.Appearance.GroupCaptionCell.Borders.Top = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.GroupCaptionCell.Borders.Bottom = new GridBorder(GridBorderStyle.Solid, paleBlue, GridBorderWeight.Thick);
            //this.gridGroupingControl1.Appearance.GroupCaptionPlusMinusCell.Borders.Top = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.GroupCaptionPlusMinusCell.Borders.Bottom = new GridBorder(GridBorderStyle.Solid, paleBlue, GridBorderWeight.Thick);
            //this.gridGroupingControl1.Appearance.GroupIndentCell.Borders.Top = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.GroupIndentCell.Borders.Bottom = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid, Color.FromArgb(227, 239, 255), Syncfusion.Windows.Forms.Grid.GridBorderWeight.ExtraThin);

            // Set the color of the text to light blue
            this.gridGroupingControl1.Appearance.GroupCaptionCell.TextColor = Color.FromArgb(50, 100, 160);

            // Set a margin for the text in the group header
            this.gridGroupingControl1.Appearance.GroupCaptionCell.TextMargins.Bottom = 3;

            //this.gridGroupingControl1.Appearance.GroupCaptionCell.Borders.Left = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.GroupCaptionCell.Borders.Right = new GridBorder(GridBorderStyle.None);
            //this.gridGroupingControl1.Appearance.GroupCaptionCell.

            #endregion

            // Width in pixels of the indentation of each child group
            this.gridGroupingControl1.TableOptions.IndentWidth = 20;

            #region Bound and unbound columns
            
            this.gridGroupingControl1.TableDescriptor.Columns.Clear();
            this.gridGroupingControl1.TableDescriptor.Columns.Add("Priority");
            this.gridGroupingControl1.TableDescriptor.Columns.Add("TaskId");
            this.gridGroupingControl1.TableDescriptor.Columns.Add("Subject");
            this.gridGroupingControl1.TableDescriptor.Columns.Add("Assignee", "AssigneeName");
            this.gridGroupingControl1.TableDescriptor.Columns.Add("Due Date", "DueDate");
            this.gridGroupingControl1.TableDescriptor.Columns.Add("OwnedBy");

            this.gridGroupingControl1.TableDescriptor.Columns["Priority"].Width = 16;
            this.gridGroupingControl1.TableDescriptor.Columns["Assignee"].Width = 100;            

            // Create a new column for the icon
            FieldDescriptor icon = new FieldDescriptor("icon", "icon", true, "");
            this.gridGroupingControl1.TableDescriptor.UnboundFields.Add(icon);
            GridColumnDescriptor cdicon = new GridColumnDescriptor(icon);
            cdicon.HeaderText = "";
            this.gridGroupingControl1.TableDescriptor.Columns.Add(cdicon);            
            this.gridGroupingControl1.TableDescriptor.Columns["icon"].Width = 16;            

            // Put the task icon at the front           
            int iconColumn = this.gridGroupingControl1.TableDescriptor.Columns.IndexOf("icon");
            this.gridGroupingControl1.TableDescriptor.Columns.Move(iconColumn, 0);

            this.gridGroupingControl1.TableDescriptor.GroupedColumns.Changed += new Syncfusion.Collections.ListPropertyChangedEventHandler(gridGroupingControl1_GroupedColumnsChanged);  

            // By default apply grouping on the date column
            this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add("DueDate");

            // Set the data source
            this.taskViewCollectionBindingSource.DataSource = GetDummyData(false);
            this.gridGroupingControl1.DataSource = this.taskViewCollectionBindingSource;            

            #endregion
        }

        # region Get the data table or dummy data

        private ListEx<TaskView> GetDummyData(bool refreshed)
        {
            ListEx<TaskView> taskList = new ListEx<TaskView>();

            taskList.Add(new TaskView(5, "Tindale", "This is the test refresh", refreshed ? DateTime.Now : (DateTime?)null, 0, 0, "Jake", "Please provide me the key to the new version", 5010, null, "LOW", 3));
            taskList.Add(new TaskView(null, "Tony", "Re: Tool Missing ", DateTime.Now.AddMinutes(-2), 0, 0, "Jake", "Thanks Jake, Now it works", 29300, null, null, 5));
            //taskList.Add(new TaskView(null, "Brown", "Essential Grid ", DateTime.Now.AddHours(-1), 0, 0, "Jake", "Will you help me in purchasing Essential Grid", 5010, null, "HIGH", null));
            //taskList.Add(new TaskView(10, "Sam", "Re:Latest Version", DateTime.Now.AddHours(-3), 0, 0, "Jake", "You can download the latest version now", 293000, 1, null, null));
            //taskList.Add(new TaskView(null, "Ted", "UserAccount", DateTime.Now.AddHours(-3), 0, 0, "Jake", "User accounts have been created", 55000, 1, null, null));
            //taskList.Add(new TaskView(5, "George", "Re: Solution", DateTime.Now.AddDays(-1), 0, 0, "Jake", "Thanks! This sorted the problem", 1025, null, null, null));
            //taskList.Add(new TaskView(1, "Paul", "New Image", DateTime.Now.AddDays(-10), 0, 0, "Jake", "Please have a look at this", 3453454, null, null, null));
            //taskList.Add(new TaskView(1, "Donald", "Re: icons", DateTime.Now.AddDays(-12), 2, 1, "Jake", "Please modify them", 3434100, null, null, null));
            //taskList.Add(new TaskView(null, "Jerry", "Re: ", DateTime.Now.AddDays(-21), 2, 1, "Jake", "The feature is added now. It is ready for testing", 2033, -1, null, null));
            //taskList.Add(new TaskView(6, "George", "Installaion Procedure", DateTime.Now.AddDays(-3), 2, 1, "Jake", "It is uploaded in server. Please go through this", 20400, null, null, null));
            //taskList.Add(new TaskView(1, "Paul", "Report Format", DateTime.Now.AddDays(-16), 3, 1, "Jake", "Please have a look at this", 3453440, 1, null, null));
            //taskList.Add(new TaskView(null, "Donald", "Code Optimizer tool", DateTime.Now.AddDays(-10), 2, 1, "Jake", "Where can I found the complete documentation", 34341, null, null, null));
            //taskList.Add(new TaskView(10, "Bob", "FeatureList", null, 2, 1, "Jake", "Could you please send me the list of new features ", 5010, null, null, null));
            //taskList.Add(new TaskView(1, "Sam", "Re: redraw issue", DateTime.Now.AddDays(-15), 1, 1, "Jake", "It is fixed", 293000, 1, null, 7));
            //taskList.Add(new TaskView(null, "Ted", "Re: Helper tool", DateTime.Now.AddDays(-14), 2, 1, "Jake", "This works great!!", 55000, 1, null, 6));
            //taskList.Add(new TaskView(10, "Babu", "Re:Defects", DateTime.Now.AddDays(-101), 1, 1, "Jake", "All Defects have been fixed.", 5010, null, null, 7));
            //taskList.Add(new TaskView(1, "Domnique", "Code file missing", DateTime.Now.AddDays(-113), 2, 1, "Jake", "Could you please resend it again", 293000, -1, null, null));
            //taskList.Add(new TaskView(null, "Haddok", "Re: resize problem", null, 2, 1, "Jake", "Thanks for your solution", 55000, 1, null, null));
            //taskList.Add(new TaskView(null, "George", "Re: ReleaseDates", DateTime.Now.AddDays(-7), 3, 1, "Jake", "It will be announced tommorrow", 1025, null, null, null));
            //taskList.Add(new TaskView(1, "Paul", "Icons", DateTime.Now.AddDays(-199), 2, 1, "Jake", "Here is a list of icons", 3453454, null, null, null));
            //taskList.Add(new TaskView(1, "Donald", "Re: FeatureList", DateTime.Now.AddDays(-2), 1, 1, "Jake", "Please find the attachment for details", 3434100, null, null, null));
            //taskList.Add(new TaskView(null, "Jerry", "Re:Latest Version", DateTime.Now.AddDays(-19), 2, 1, "Jake", "You can download the latest version now", 2033, -1, null, null));
            //taskList.Add(new TaskView(null, "George", "Re: scrolling issue", DateTime.Now.AddDays(-17), 2, 1, "Jake", "It is fixed", 20400, null, null, null));
            //taskList.Add(new TaskView(1, "Paul", "New sample", DateTime.Now.AddDays(-12), 1, 1, "Jake", "Please test this", 3454540, 1, null, null));
            //taskList.Add(new TaskView(null, "Don", "Re: Evaluation Keys", DateTime.Now.AddDays(-12), 2, 1, "Jake", "Hello, Finally decided purchasing Essential Grid.", 34341, null, null, null));
            //taskList.Add(new TaskView(null, "George", "New website ", DateTime.Now.AddDays(4), 1, 1, "Jake", "Please send me the link", 20400, null, null, null));
            //taskList.Add(new TaskView(null, "Paul", "Refresh issues", DateTime.Now.AddDays(14), 1, 1, "Jake", "Please check them", 3453540, 1, null, null));
            //taskList.Add(new TaskView(1, "Don", "Re: UI design", DateTime.Now.AddDays(-32), 2, 1, "Jake", "Thanks for your pointers! we came up with solution", 34341, null, "Green Category", null));
            //taskList.Add(new TaskView(null, "Neal Culiner", "Kudos Folks!!!", DateTime.Now.AddDays(-13), 2, 1, "Jake", "All I can say is WOW! Beautiful works!", 1025, null, "Purple Category", null));
            //taskList.Add(new TaskView(null, "Paul", "Re: License issue", DateTime.Now.AddDays(-12), 3, 1, "Jake", "Thanks!!", 3453454, null, null, null));
            //taskList.Add(new TaskView(1, "Don", "UI design", DateTime.Now.AddDays(-357), 3, 1, "Jake", "Will it be possible to tune grids as in the attachment.", 3434100, null, null, null));
            //taskList.Add(new TaskView(null, "Jerry", "Evalutation", DateTime.Now.AddDays(-16), 2, 1, "Jake", "Testing is completed. This product works fine", 2033, null, null, null));
            //taskList.Add(new TaskView(null, "Patrick", "Feedback", DateTime.Now.AddDays(5), 2, 1, "Jake", "Thanks for your extraordinary support.", 20400, null, null, null));
            //taskList.Add(new TaskView(null, "Paul", "License issue", DateTime.Now.AddDays(-4), 3, 1, "Jake", "How do I enable license to my customers?", 344540, 1, null, null));
            //taskList.Add(new TaskView(null, "Don", "Evaluation Keys", DateTime.Now.AddDays(-5), 1, 1, "Jake", "Can you send the keys to test your produts.", 34341, null, null, 8));
            return taskList;
        }

        # endregion

        private void gridGroupingControl1_GroupCollapsed(object sender, Syncfusion.Grouping.GroupEventArgs e)
        {
            GridCaptionRow gcr = (GridCaptionRow)e.Group.Caption.CaptionRows[0];
            gcr.Appearance.GroupCaptionPlusMinusCell.CellValue = Properties.Resources.PlusImage;
        }

        private void gridGroupingControl1_GroupExpanded(object sender, Syncfusion.Grouping.GroupEventArgs e)
        {
            GridCaptionRow gcr = (GridCaptionRow)e.Group.Caption.CaptionRows[0];
            gcr.Appearance.GroupCaptionPlusMinusCell.CellValue = Properties.Resources.MinusImage;
        }

        private void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            if (e.Style != null && e.TableCellIdentity != null & e.TableCellIdentity.Column != null)
            {
                // Get the row index
                int rowIndex = e.TableCellIdentity.RowIndex;

                // Set the icons
                switch (e.TableCellIdentity.Column.Name)
                {
                    case "icon":
                        // apply to all record fields
                        if (e.Style.CellType != "ColumnHeaderCell")
                        {
                            e.Style.CellType = "Icon";
                            e.Style.ImageList = taskIcons;
                            e.Style.ImageIndex = Convert.ToInt32(e.Style.CellValue);
                            e.Style.ImageSizeMode = GridImageSizeMode.CenterImage;
                        }
                        break;

                    case "Priority":                        
                        if (e.Style.CellType != "ColumnHeaderCell")
                        {
                            e.Style.CellType = "Image";
                            if (e.Style.Text == "LOW")
                                e.Style.CellValue = Properties.Resources.LowPriorityImage;
                            else if (e.Style.Text == "HIGH")
                                e.Style.CellValue = Properties.Resources.HighPriorityImage;
                        }
                        else
                        {
                            e.Style.Text = "";
                            e.Style.CellValue = Properties.Resources.PriorityImage;
                        }
                        break;
                }

                // Set the row colours
                if (rowIndex != -1 && this.gridGroupingControl1.Table.DisplayElements[rowIndex] is GridRecordRow)
                {
                    //System.Diagnostics.Debug.WriteLine(rowIndex.ToString());

                    TaskView taskView = this.GetTaskView(e.TableCellIdentity.RowIndex);
                    if (taskView != null && taskView.TaskId == 5)
                        e.Style.BaseStyle = "Completed";
                    else if (taskView != null && taskView.TaskId == 10)
                        e.Style.BaseStyle = "Overdue";                        
                    else
                        e.Style.TextColor = Color.Black;                    
                }
            }


            if ((e.TableCellIdentity.TableCellType == GridTableCellType.GroupCaptionCell && e.TableCellIdentity.RowIndex > 1))
            {
                if (gridGroupingControl1.TableDescriptor.GroupedColumns.IndexOf("DueDate") > -1)
                {
                    string itemCount = " (" + e.TableCellIdentity.DisplayElement.ParentGroup.GetFilteredRecordCount() + ")";

                    // Get the value that relates to this particular group
                    string groupValue = e.TableCellIdentity.DisplayElement.ParentGroup.Category.ToString();

                    // Convert the group value into an enum
                    days dayEnum = (days)Convert.ToInt32(groupValue);

                    // Set the caption for the group header
                    string caption = "";
                    switch (dayEnum)
                    {
                        case days.LastWeek:
                            caption = "Last Week"; break;

                        case days.TwoWeeksAgo:
                            caption = "Two Weeks Ago"; break;

                        case days.ThreeWeeksAgo:
                            caption = "Three Weeks Ago"; break;

                        case days.LastMonth:
                            caption = "Last Month"; break;

                        case days.TwoWeeksTime:
                            caption = "In Two Weeks"; break;

                        case days.ThreeWeeksTime:
                            caption = "In Three Weeks"; break;

                        case days.InTheFuture:
                            caption = "In The Future"; break;

                        default:
                            caption = dayEnum.ToString(); break;
                    }
                    e.Style.Text = "Date: " + caption;
                }
            }
        }

        private void gridGroupingControl1_QueryValue(object sender, FieldValueEventArgs e)
        {
            Syncfusion.Grouping.Record rd;

            switch (e.Field.Name)
            {
                case "icon":
                    rd = (Syncfusion.Grouping.Record)e.Record;
                    if (rd.GetValue("RecurrenceId") == null)
                        e.Value = (int)taskIcon.Task;
                    else
                        e.Value = (int)taskIcon.Recurrence;
                    break;
            }
        }

        private void gridGroupingControl1_GroupedColumnsChanged(object sender, Syncfusion.Collections.ListPropertyChangedEventArgs e)
        {
            if (e.Action == Syncfusion.Collections.ListPropertyChangedType.Insert || e.Action == Syncfusion.Collections.ListPropertyChangedType.Add)
            {
                SortColumnDescriptor column = e.Item as SortColumnDescriptor;
                if (column.Name == "DueDate")
                {
                    column.GroupSortOrderComparer = new CustomeDateGroupSort();
                    column.Categorizer = new DateCustomCategorizer();
                }
            }
        }

        private void gridGroupingControl1_TableControlCellClick(object sender, GridTableControlCellClickEventArgs e)
        {
            //System.Diagnostics.Debug.WriteLine("gridGroupingControl1_TableControlCellClick");

            // When the left mouse button is single clicked on the expand/collaps 
            // icon toggle the expand state of the group
            if (e.Inner.MouseEventArgs.Button == MouseButtons.Left)
            {
                GridTableCellStyleInfo style = e.TableControl.GetTableViewStyleInfo(e.Inner.RowIndex, e.Inner.ColIndex);
                if (style.TableCellIdentity.TableCellType == GridTableCellType.GroupCaptionPlusMinusCell)
                {
                    if (e.Inner.RowIndex > 1 && e.TableControl.Table.CurrentElement is GridCaptionSection)
                    {
                        GridCaptionSection gridCapSelection = e.TableControl.Table.CurrentElement as GridCaptionSection;
                        if (gridCapSelection.ParentGroup != null)
                            gridCapSelection.ParentGroup.IsExpanded = !gridCapSelection.ParentGroup.IsExpanded;
                    }
                    else if (e.Inner.RowIndex > 1 && e.TableControl.Table.CurrentElement is GridCaptionRow)
                    {
                        GridCaptionRow gridCapRow = e.TableControl.Table.CurrentElement as GridCaptionRow;
                        if (gridCapRow.ParentGroup != null)
                            gridCapRow.ParentGroup.IsExpanded = !gridCapRow.ParentGroup.IsExpanded;
                    }
                }
            }
        }

        #region Date Custom Categorizer class
        
        public class DateCustomCategorizer : Syncfusion.Grouping.IGroupByColumnCategorizer
        {
            #region IGroupByColumnCategorizer Members

            public int CompareCategoryKey(SortColumnDescriptor column, bool isForeignKey, object category, Record record)
            {                
                return (int)GetCategory((DateTime?)record.GetValue(column)) - (int)category;
            }

            public object GetGroupByCategoryKey(SortColumnDescriptor column, bool isForeignKey, Record record)
            {                
                return (int)GetCategory((DateTime?)record.GetValue(column));
            }

            #endregion

            public days GetCategory(DateTime? dateTime)
            {
                // If there is no date there is no need to contunue
                if (dateTime.HasValue == false)
                    return days.None;


                // Get a 0 based week number (0 for this week, etc...)
                int weekNumber = GetCustomWeekNumber(dateTime.Value);

                if (weekNumber < -3)
                    return days.Older;

                else if (weekNumber == -3)
                    return days.ThreeWeeksAgo;

                else if (weekNumber == -2)
                    return days.TwoWeeksAgo;

                else if (weekNumber == -1)
                    return days.LastWeek;

                else if (weekNumber == 0)
                {
                    if (dateTime.Value.Date == DateTime.Today)
                        return days.Today;
                    else if (dateTime.Value.Date == DateTime.Today.AddDays(-1))
                        return days.Yesterday;
                    else
                        return (days)Enum.Parse(typeof(days), dateTime.Value.DayOfWeek.ToString());
                }

                else if (weekNumber == 1)
                    return days.NextWeek;

                else if (weekNumber == 2)
                    return days.TwoWeeksTime;

                else if (weekNumber == 3)
                    return days.ThreeWeeksTime;

                else if (weekNumber > 3)
                    return days.InTheFuture;

                else
                    throw new ApplicationException("The date doesn't fit into any of the date windows defined " + dateTime.Value.ToString());

            }

            private string GetDayOfWeek(int intDay)
            {
                return ((DayOfWeek)intDay).ToString();
            }

            /// <summary>
            /// Get a 0 based week number
            /// </summary>
            /// <remarks></remarks>
            /// <param name="dateTime"></param>
            /// <returns>
            /// -2 - two weeks ago
            /// -1 - one week ago
            /// 0 - this week
            /// 1 - next week
            /// 2 - two weeks time
            /// </returns>
            private int GetCustomWeekNumber(DateTime dateTime)
            {
                int weekNumber;

                // Get the first day of this week
                DateTime firstDayOfWeek = GetFirstDayOfWeek(DateTime.Today);

                // Get the number of days from the date specified
                int daysDiff = (dateTime.Date - firstDayOfWeek.Date).Days;

                // Calculate which week the date specified is in(it's a simple divide by 7)
                if (daysDiff < 0)
                    weekNumber = (int)Math.Truncate(daysDiff / 7.0) - 1;
                else
                    weekNumber = (int)Math.Truncate(daysDiff / 7.0);

                return weekNumber;
            }

            private DateTime GetFirstDayOfWeek(DateTime date)
            {
                // Use the weekday enum to determine the offset (I could have used the enum 
                // directly to perform a calculation but it's not very safe as we can't rely
                // on the enums order and basing
                switch (date.DayOfWeek)
                {
                    case DayOfWeek.Monday:
                        return date.Date;

                    case DayOfWeek.Tuesday:
                        return date.Date.AddDays(-1);

                    case DayOfWeek.Wednesday:
                        return date.Date.AddDays(-2);

                    case DayOfWeek.Thursday:
                        return date.Date.AddDays(-3);

                    case DayOfWeek.Friday:
                        return date.Date.AddDays(-4);

                    case DayOfWeek.Saturday:
                        return date.Date.AddDays(-5);

                    case DayOfWeek.Sunday:
                        return date.Date.AddDays(-6);

                    default:
                        throw new InvalidEnumArgumentException("date.DayOfWeek", (int)date.DayOfWeek, typeof(System.DayOfWeek));
                }
            }
        }

        #endregion

        #region Custom Date Group Sort class

        public class CustomeDateGroupSort : IComparer
	    {	
		    public int Compare(object x, object y)
		    {
			    Group gx = (Group) x;
			    Group gy = (Group) y;
    				
		        int gxRecordCount =  (int)gx.Category;
                int gyRecordCount = (int)gy.Category;

		        return gyRecordCount-gxRecordCount;
		    }
	    }        

        #endregion

        private void gridGroupingControl1_DoubleClick(object sender, EventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("gridGroupingControl1_DoubleClick");
        }

        private void gridGroupingControl1_TableControlCellDoubleClick(object sender, GridTableControlCellClickEventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("gridGroupingControl1_TableControlCellDoubleClick " + e.Inner.RowIndex);

            // When the left mouse button is double clicked on a data row
            if (e.Inner.MouseEventArgs.Button == MouseButtons.Left && e.TableControl.Table.CurrentElement is GridRecord)
            {
                // Get the row index
                int rowIndex = e.Inner.RowIndex;

                // Get the taskview object from datasource
                TaskView taskView = GetTaskView(rowIndex);

                // Show the subject
                MessageBox.Show(taskView.Subject);
            }
        }

        private TaskView GetTaskView(int rowIndex)
        {
            // Get the table - this holds the flat view of the records in the data source
            Table table = gridGroupingControl1.Table;
            
            // Get the element that corresponds to this index - Elements are the base type
            Element element = table.DisplayElements[rowIndex];

            // Get the record from the element
            Record record = element.ParentRecord;
            if (record == null)
                throw new ApplicationException("There is no underlying record for the rowIndex " + rowIndex.ToString());

            // Get the index of the record we have idnetified, this index can be used in the data soruce
            int dataSourceIndex = table.UnsortedRecords.IndexOf(record);

            // Get the taskview object from datasource
            TaskView taskView = (TaskView)taskViewCollectionBindingSource[dataSourceIndex];

            // Return the taskView object
            return taskView;

        }

        private void refreshToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.taskViewCollectionBindingSource.DataSource = GetDummyData(true);            
            //this.taskViewCollectionBindingSource.SuspendBinding();
            //this.taskViewCollectionBindingSource.ResumeBinding();
            //this.gridGroupingControl1.Table.TableDirty = true;            
            //this.gridGroupingControl1.Refresh();            
            this.gridGroupingControl1.Reinitialize();
        }
    }
}